# Generated by go2rpm
%ifnarch ppc64le
%bcond_without check
%endif

# https://github.com/google/trillian
%global goipath         github.com/google/trillian
Version:                1.4.0

%gometa

%global common_description %{expand:
Trillian is an implementation of the concepts described in the Verifiable Data
Structures white paper, which in turn is an extension and generalisation of the
ideas which underpin Certificate Transparency.

Trillian implements a Merkle tree whose contents are served from a data storage
layer, to allow scalability to extremely large trees.}

%global golicenses      LICENSE
%global godocs          docs examples CONTRIBUTING.md AUTHORS CHANGELOG.md\\\
                        CONTRIBUTORS README.md

Name:           %{goname}
Release:        %autorelease
Summary:        Transparent, highly scalable and cryptographically verifiable data store

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}

BuildRequires:  golang(bitbucket.org/creachadair/shell)
BuildRequires:  golang(cloud.google.com/go/spanner)
BuildRequires:  golang(cloud.google.com/go/spanner/spansql)
BuildRequires:  golang(contrib.go.opencensus.io/exporter/stackdriver)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam/core/runtime)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam/core/runtime/exec)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam/core/runtime/graphx/schema)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam/core/util/reflectx)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam/io/filesystem/local)
BuildRequires:  golang(github.com/apache/beam/sdks/v2/go/pkg/beam/x/beamx)
BuildRequires:  golang(github.com/go-redis/redis)
BuildRequires:  golang(github.com/go-sql-driver/mysql)
BuildRequires:  golang(github.com/golang/glog)
BuildRequires:  golang(github.com/golang/mock/gomock)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/any)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/duration)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/empty)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/timestamp)
BuildRequires:  golang(github.com/google/btree)
BuildRequires:  golang(github.com/google/certificate-transparency-go/tls)
BuildRequires:  golang(github.com/google/go-cmp/cmp)
BuildRequires:  golang(github.com/grpc-ecosystem/go-grpc-middleware)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus/promhttp)
BuildRequires:  golang(github.com/prometheus/client_model/go)
BuildRequires:  golang(go.etcd.io/etcd/client/v3)
BuildRequires:  golang(go.etcd.io/etcd/client/v3/concurrency)
BuildRequires:  golang(go.etcd.io/etcd/client/v3/naming/endpoints)
BuildRequires:  golang(go.etcd.io/etcd/server/v3/embed)
BuildRequires:  golang(go.etcd.io/etcd/server/etcdserver/api/v3rpc)
BuildRequires:  golang(go.opencensus.io/plugin/ocgrpc)
BuildRequires:  golang(go.opencensus.io/plugin/ochttp)
BuildRequires:  golang(go.opencensus.io/stats/view)
BuildRequires:  golang(go.opencensus.io/trace)
BuildRequires:  golang(golang.org/x/crypto/ed25519)
BuildRequires:  golang(golang.org/x/sync/errgroup)
BuildRequires:  golang(golang.org/x/sync/semaphore)
BuildRequires:  golang(golang.org/x/sys/unix)
BuildRequires:  golang(google.golang.org/api/option)
BuildRequires:  golang(google.golang.org/genproto/googleapis/api/annotations)
BuildRequires:  golang(google.golang.org/genproto/googleapis/rpc/status)
BuildRequires:  golang(google.golang.org/genproto/protobuf/field_mask)
BuildRequires:  golang(google.golang.org/grpc)
BuildRequires:  golang(google.golang.org/grpc/codes)
BuildRequires:  golang(google.golang.org/grpc/credentials)
BuildRequires:  golang(google.golang.org/grpc/reflection)
BuildRequires:  golang(google.golang.org/grpc/status)
BuildRequires:  golang(google.golang.org/protobuf/encoding/prototext)
BuildRequires:  golang(google.golang.org/protobuf/proto)
BuildRequires:  golang(google.golang.org/protobuf/reflect/protoreflect)
BuildRequires:  golang(google.golang.org/protobuf/reflect/protoregistry)
BuildRequires:  golang(google.golang.org/protobuf/runtime/protoimpl)
BuildRequires:  golang(google.golang.org/protobuf/testing/protocmp)
BuildRequires:  golang(google.golang.org/protobuf/types/known/anypb)
BuildRequires:  golang(google.golang.org/protobuf/types/known/durationpb)
BuildRequires:  golang(google.golang.org/protobuf/types/known/emptypb)
BuildRequires:  golang(google.golang.org/protobuf/types/known/timestamppb)

%if %{with check}
# Tests
BuildRequires:  golang(cloud.google.com/go/spanner/admin/database/apiv1)
BuildRequires:  golang(cloud.google.com/go/spanner/spannertest)
BuildRequires:  golang(github.com/apache/beam/sdks/go/pkg/beam/testing/passert)
BuildRequires:  golang(github.com/apache/beam/sdks/go/pkg/beam/testing/ptest)
BuildRequires:  golang(github.com/apache/beam/sdks/go/pkg/beam/transforms/filter)
BuildRequires:  golang(github.com/apache/beam/sdks/go/pkg/beam/transforms/stats)
BuildRequires:  golang(github.com/google/go-cmp/cmp/cmpopts)
BuildRequires:  golang(google.golang.org/genproto/googleapis/rpc/code)
BuildRequires:  golang(google.golang.org/genproto/googleapis/spanner/admin/database/v1)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
sed -i "s|github.com/go-redis/redis|gopkg.in/redis.v6|" $(find . -name "*.go")
sed -i "s|github.com/apache/beam/sdks|github.com/apache/beam/sdks/v2|" $(find . -name "*.go")

%install
%gopkginstall

%if %{with check}
%check
# client/rpcflags, cmd/get_tree_public_key, storage/testdb, quota/redis/redistb: needs network
%gocheck -d client/rpcflags \
         -t cmd \
         -d server \
         -d storage/testdb \
         -d util/election \
         -d quota/redis/redistb \
         -d crypto
%endif

%gopkgfiles

%changelog
%autochangelog
